# Expense Reimbursement System (ERS)

Project 1 will be an individual project be based off of an employee expense reimbursement system (or similar\*). It will be a full stack application utilizing HTML, CSS, and JavaScript on the frontend and a Java application on the backend. This Java application will utilize Servlets to process user requests from the front end. The following user stories are required of the application:

- An Employee can login
- An Employee can view the Employee Homepage
- An Employee can logout

---

- An Employee can submit a reimbursement request
- An Employee can view their pending reimbursement requests
- An Employee can view their resolved reimbursement requests

---

- A Manager can login
- A Manager can view the Manager Homepage
- A Manager can logout

---

- A Manager can approve/deny pending reimbursement requests
- A Manager can view all pending requests from all employees

Additional Requirements:
Testing application code
Logging using log4j or a similar logging framework

## Optional User Stories:

- An Employee can view their information (profile)
- An Employee can update their information
- A Manager can view all resolved requests from all employees and see which manager resolved it
- A Manager can view all Employees

---

- An Employee can upload an image of his/her receipt as part of the reimbursement request
- A Manager can view images of the receipts from reimbursement requests
- An Employee receives an email when one of their reimbursement requests is resolved
- A Manager can register an Employee, which sends the Employee an email with their username and temp password
- An Employee can reset their password
- Password encryption
- Including visual aids, such as charts showing spending categories or spending over time
- Ensuring code quality with a static code analysis

## Technologies:

- Java 1.8
- Servlets
- JDBC
- SQL
- HTML
- CSS
- Javascript
- Bootstrap
- AJAX
- JUnit
- log4j

## Environment:

- Tomcat Server
- Oracle Database
- Eclipse/Spring Tools Suite
- DBeaver

\*It is possible to do a variation of the ERS system if you’d like. If you have a similar idea that you would like to implement, it can be discussed with your trainer, as long as equivalent user stories that can be defined
